Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/HTML.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/HTML.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/HTML.pm	(revision 34921)
@@ -21,5 +21,5 @@
 require Exporter;
 
-$VERSION = '1.11';
+$VERSION = '1.16';
 @ISA = qw(Exporter);
 @EXPORT_OK = qw(EscapeHTML UnescapeHTML);
@@ -161,4 +161,5 @@
     author          => { },
     classification  => { },
+   'content-language'=>{ Name => 'ContentLanguage' },
     copyright       => { },
     description     => { },
@@ -169,4 +170,5 @@
     formatter       => { },
     generator       => { },
+    generatorversion=> { Name => 'GeneratorVersion' },
     googlebot       => { Name => 'GoogleBot' },
     keywords        => { List => 1 },
@@ -335,6 +337,6 @@
 sub SetHTMLCharset($$)
 {
-    my ($val, $exifTool) = @_;
-    $$exifTool{HTMLCharset} = $htmlCharset{lc $1} if $val =~ /charset=['"]?([-\w]+)/;
+    my ($val, $et) = @_;
+    $$et{HTMLCharset} = $htmlCharset{lc $1} if $val =~ /charset=['"]?([-\w]+)/;
     return $val;
 }
@@ -343,5 +345,5 @@
 # Convert single UTF-8 character to HTML character reference
 # Inputs: 0) UTF-8 character sequence
-# Returns: HTML character reference (ie. "&quot;");
+# Returns: HTML character reference (eg. "&quot;");
 # Note: Must be called via EscapeHTML to load name lookup
 sub EscapeChar($)
@@ -362,9 +364,9 @@
 #------------------------------------------------------------------------------
 # Escape any special characters for HTML
-# Inputs: 0) UTF-8 string to be escaped
+# Inputs: 0) string to be escaped, 1) optional string encoding (default 'UTF8')
 # Returns: escaped string
-sub EscapeHTML($)
+sub EscapeHTML($;$)
 {
-    my $str = shift;
+    my ($str, $enc) = @_;
     # escape XML characters
     $str = EscapeXML($str);
@@ -381,6 +383,12 @@
         # suppress warnings
         local $SIG{'__WARN__'} = sub { 1 };
-        # escape any non-ascii characters for HTML
-        $str =~ s/([\xc2-\xf7][\x80-\xbf]+)/EscapeChar($1)/sge;
+        if ($enc and $enc ne 'UTF8') {
+            $str = Image::ExifTool::Decode(undef, $str, $enc, undef, 'UTF8');
+            $str =~ s/([\xc2-\xf7][\x80-\xbf]+)/EscapeChar($1)/sge;
+            $str = Image::ExifTool::Decode(undef, $str, 'UTF8', undef, $enc);
+        } else {
+            # escape any non-ascii characters for HTML
+            $str =~ s/([\xc2-\xf7][\x80-\xbf]+)/EscapeChar($1)/sge;
+        }
     }
     return $str;
@@ -389,9 +397,10 @@
 #------------------------------------------------------------------------------
 # Unescape all HTML character references
-# Inputs: 0) string to be unescaped
+# Inputs: 0) string to be unescaped, 1) optional string encoding (default 'UTF8')
 # Returns: unescaped string
-sub UnescapeHTML($)
+sub UnescapeHTML($;$)
 {
-    return UnescapeXML(shift, \%entityNum);
+    my ($str, $enc) = @_;
+    return UnescapeXML($str, \%entityNum, $enc);
 }
 
@@ -402,5 +411,5 @@
 sub ProcessHTML($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $buff;
@@ -408,12 +417,12 @@
     # validate HTML or XHTML file
     $raf->Read($buff, 256) or return 0;
-    $buff =~ /^<(!DOCTYPE\s+HTML|HTML|\?xml)/i or return 0;
-    $buff =~ /<(!DOCTYPE\s+)?HTML/i or return 0 if $1 eq '?xml';
-    $exifTool->SetFileType();
-
-    $raf->Seek(0,0) or $exifTool->Warn('Seek error'), return 1;
+    $buff =~ /^(\xef\xbb\xbf)?\s*<(!DOCTYPE\s+HTML|HTML|\?xml)/i or return 0;
+    $buff =~ /<(!DOCTYPE\s+)?HTML/i or return 0 if $2 eq '?xml';
+    $et->SetFileType();
+
+    $raf->Seek(0,0) or $et->Warn('Seek error'), return 1;
 
     local $/ = Image::ExifTool::PostScript::GetInputRecordSeparator($raf);
-    $/ or $exifTool->Warn('Invalid HTML data'), return 1;
+    $/ or $et->Warn('Invalid HTML data'), return 1;
 
     # extract header information
@@ -438,5 +447,7 @@
         my $tag = lc($tagName);
         my ($val, $grp);
-        unless ($attrs =~ m{/$}) {  # self-contained XHTML tags end in '/>'
+        if ($attrs =~ m{/$}) {  # self-contained XHTML tags end in '/>'
+            $val = '';
+        } else {
             # look for element close
             my $pos = pos($doc);
@@ -450,4 +461,5 @@
                 pos($doc) = $pos;
                 next unless $tag eq 'meta'; # META tags don't need to be closed
+                $val = '';
             }
         }
@@ -457,19 +469,24 @@
             undef $tag;
             # tag name is in NAME or HTTP-EQUIV attribute
-            if ($attrs =~ /name=['"]?([\w:.-]+)/si) {
+            if ($attrs =~ /\bname\s*=\s*['"]?([\w:.-]+)/si) {
                 $tagName = $1;
-            } elsif ($attrs =~ /http-equiv=['"]?([\w:.-]+)/si) {
+            } elsif ($attrs =~ /\bhttp-equiv\s*=\s*['"]?([\w:.-]+)/si) {
                 $tagName = "HTTP-equiv.$1";
             } else {
                 next;   # no name
             }
-            $tag = lc($tagName);
+            $tag = lc($tagName) or next;
             # tag value is in CONTENT attribute
-            $val = $2 if $attrs =~ /content=(['"])(.*?)\1/si;
-            next unless $tag and defined $val;
+            if ($attrs =~ /\bcontent\s*=\s*(['"])(.*?)\1/si or
+                $attrs =~ /\bcontent\s*=\s*(['"]?)([\w:.-]+)/si)
+            {
+                $val = $2;
+            } else {
+                next unless length $val;
+            }
             # isolate group name (separator is '.' in HTML, but ':' in ref 2)
             if ($tag =~ /^([\w-]+)[:.]([\w-]+)/) {
                 ($grp, $tag) = ($1, $2);
-                my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $grp);
+                my $tagInfo = $et->GetTagInfo($tagTablePtr, $grp);
                 if ($tagInfo and $$tagInfo{SubDirectory}) {
                     $table = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
@@ -479,10 +496,10 @@
             }
         } elsif ($tag eq 'xml') {
-            $exifTool->VPrint(0, "Parsing XML\n");
+            $et->VPrint(0, "Parsing XML\n");
             # parse XML tags (quick-and-dirty)
             my $xml = $val;
             while ($xml =~ /<([\w-]+):([\w-]+)(\s.*?)?>([^<]*?)<\/\1:\2>/g) {
                 ($grp, $tag, $val) = ($1, $2, $4);
-                my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $grp);
+                my $tagInfo = $et->GetTagInfo($tagTablePtr, $grp);
                 next unless $tagInfo and $$tagInfo{SubDirectory};
                 $table = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
@@ -492,9 +509,9 @@
                     $name =~ s/\s(.)/\U$1/g;     # capitalize all words in tag name
                     $name =~ tr/-_a-zA-Z0-9//dc; # remove illegal characters (also hex code wide chars)
-                    Image::ExifTool::AddTagToTable($table, $tag, { Name => $name });
-                    $exifTool->VPrint(0, "  [adding $tag '$name']\n");
+                    AddTagToTable($table, $tag, { Name => $name });
+                    $et->VPrint(0, "  [adding $tag '${name}']\n");
                 }
-                $val = $exifTool->Decode($val, $$exifTool{HTMLCharset}) if $$exifTool{HTMLCharset};
-                $exifTool->HandleTag($table, $tag, UnescapeXML($val));
+                $val = $et->Decode($val, $$et{HTMLCharset}) if $$et{HTMLCharset};
+                $et->HandleTag($table, $tag, UnescapeXML($val));
             }
             next;
@@ -508,12 +525,12 @@
             my $info = { Name => $name, Groups => { 0 => 'HTML' } };
             $info->{Groups}->{1} = ($grp eq 'http-equiv' ? 'HTTP-equiv' : "HTML-$grp") if $grp;
-            Image::ExifTool::AddTagToTable($table, $tag, $info);
-            $exifTool->VPrint(0, "  [adding $tag '$tagName']\n");
+            AddTagToTable($table, $tag, $info);
+            $et->VPrint(0, "  [adding $tag '${tagName}']\n");
         }
         # recode if necessary
-        $val = $exifTool->Decode($val, $$exifTool{HTMLCharset}) if $$exifTool{HTMLCharset};
+        $val = $et->Decode($val, $$et{HTMLCharset}) if $$et{HTMLCharset};
         $val =~ s{\s*$/\s*}{ }sg;   # replace linefeeds and indenting spaces
         $val = UnescapeHTML($val);  # unescape HTML character references
-        $exifTool->HandleTag($table, $tag, $val);
+        $et->HandleTag($table, $tag, $val);
     }
     return 1;
@@ -539,5 +556,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/HtmlDump.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/HtmlDump.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/HtmlDump.pm	(revision 34921)
@@ -14,7 +14,7 @@
 use Image::ExifTool::HTML qw(EscapeHTML);
 
-$VERSION = '1.30';
-
-sub DumpTable($$$;$$$$$);
+$VERSION = '1.39';
+
+sub DumpTable($$$;$$$$$$);
 sub Open($$$;@);
 sub Write($@);
@@ -33,4 +33,5 @@
 my $htmlHeader2 = <<_END_PART_2_;
 </title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <style type="text/css">
 <!--
@@ -61,8 +62,10 @@
     position: absolute;
     background: #ffffdd;
+    zoom: 1;
+    -moz-opacity: 0.8;
+    -khtml-opacity: 0.8;
+    -ms-filter: 'progid:DXImageTransform.Microsoft.Alpha(Opacity=80)';
+    filter: alpha(opacity=80);
     opacity: 0.8;
-    -moz-opacity: 0.8;
-    filter: alpha(opacity=80);
-    -ms-filter: 'progid:DXImageTransform.Microsoft.Alpha(Opacity=80)';
     z-index: 2;
 }
@@ -95,5 +98,6 @@
 var ie6 = navigator.userAgent.toLowerCase().indexOf('msie 6') >= 0;
 var mspan = new Array;
-var hlist, tt, tb;
+var clicked = 0;
+var hlist, tt, tb, firstOutEvt, lastInEvt;
 
 function GetElementsByClass(classname, tagname) {
@@ -110,6 +114,19 @@
     }
   }
-  delete list;
   return found;
+}
+
+// click mouse
+function doClick(e)
+{
+  if (!clicked) {
+    firstOutEvt = lastInEvt = undefined;
+    high(e, 2);
+    if (hlist) clicked = 1;
+  } else {
+    clicked = 0;
+    if (firstOutEvt) high(firstOutEvt, 0);
+    if (lastInEvt) high(lastInEvt, 1);
+  }
 }
 
@@ -161,4 +178,10 @@
 // highlight/unhighlight text
 function high(e,on) {
+  if (on) {
+    lastInEvt = e;
+  } else {
+    if (!firstOutEvt) firstOutEvt = e;
+  }
+  if (clicked) return;
   var targ;
   if (e.target) targ = e.target;
@@ -170,5 +193,7 @@
     if (hlist) {
       for (var i=0; i<hlist.length; ++i) {
-        hlist[i].style.background = 'transparent';
+        for (var j=0; j<hlist[i].length; ++j) {
+          hlist[i][j].style.background = 'transparent';
+        }
       }
       hlist = null;
@@ -189,18 +214,23 @@
       }
       // highlight anchor elements with the same name
-      hlist = document.getElementsByName(targ.name);
+      hlist = new Array;
+      hlist.push(document.getElementsByName(targ.name));
+      // is this an IFD pointer?
+      var pos = targ.className.indexOf('Offset_');
+      if (pos > 0) {
+        // add elements from this IFD to our highlight list
+        hlist.push(document.getElementsByClassName(targ.className.substr(pos+7)));
+      }
       // use class name to highlight span elements if necessary
       for (var i=0; i<mspan.length; ++i) {
         if (mspan[i] != targ.name) continue;
-        var slist = GetElementsByClass(targ.name, 'span');
-        // add elements from hlist collection to our array
-        for (var j=0; j<hlist.length; ++j) {
-            slist[slist.length] = hlist[j];
-        }
-        hlist = slist;
+        // add these span elements to our highlight list
+        hlist.push(GetElementsByClass(targ.name, 'span'));
         break;
       }
-      for (var j=0; j<hlist.length; ++j) {
-        hlist[j].style.background = '#ffcc99';
+      for (var i=0; i<hlist.length; ++i) {
+        for (var j=0; j<hlist[i].length; ++j) {
+          hlist[i][j].style.background = on == 2 ? '#ffbbbb' : '#ffcc99';
+        }
       }
     }
@@ -218,5 +248,5 @@
 <tr><td valign='top'><pre>];
 
-my $preMouse = q(<pre onmouseover="high(event,1)" onmouseout="high(event,0)" onmousemove="move(event)">);
+my $preMouse = q(<pre onmouseover="high(event,1)" onmouseout="high(event,0)" onmousemove="move(event)" onmousedown="doClick(event)">);
 
 #------------------------------------------------------------------------------
@@ -235,5 +265,5 @@
 # Inputs: 0) HTML dump hash ref, 1) absolute offset in file, 2) data size,
 #         3) comment string, 4) tool tip (or SAME to use previous tip),
-#         5) bit flags (see below)
+#         5) bit flags (see below), 6) IFD name
 # Bits: 0x01 - print at start of line
 #       0x02 - print red address
@@ -243,7 +273,7 @@
 #       0x100 - (reserved)
 # Notes: Block will be shown in 'unused' color if comment string begins with '['
-sub Add($$$$;$)
+sub Add($$$$;$$)
 {
-    my ($self, $start, $size, $msg, $tip, $flag) = @_;
+    my ($self, $start, $size, $msg, $tip, $flag, $ifd) = @_;
     my $block = $$self{Block};
     $$block{$start} or $$block{$start} = [ ];
@@ -262,5 +292,5 @@
         ++$self->{TipNum};
     }
-    push @{$$block{$start}}, [ $size, $msg, $htip, $flag, $self->{TipNum} ];
+    push @{$$block{$start}}, [ $size, $msg, $htip, $flag, $self->{TipNum}, $ifd ];
 }
 
@@ -313,11 +343,18 @@
     # only do dump if we didn't have a serious error
     @starts = sort { $a <=> $b } keys %$block unless $$self{Error};
-    for ($i=0; $i<@starts; ++$i) {
+    for ($i=0; $i<=@starts; ++$i) {
         my $start = $starts[$i];
-        my $parmList = $$block{$start};
+        my $parmList;
+        if (defined $start) {
+            $parmList = $$block{$start};
+        } elsif ($bkgEnd and $pos < $bkgEnd and not defined $wasUnused) {
+            $start = $bkgEnd;   # finish last bkg block
+        } else {
+            last;
+        }
         my $len = $start - $pos;
         if ($len > 0 and not $wasUnused) {
-            # we have an unused bytes before this data block
-            --$i;           # dump the data block next time around
+            # we have a unused bytes before this data block
+            --$i;   # dump the data block next time around
             # split unused data into 2 blocks if it spans end of a bkg block
             my ($nextBkgEnd, $bkg);
@@ -343,5 +380,5 @@
         my $parms;
         foreach $parms (@$parmList) {
-            my ($len, $msg, $tip, $flag, $tipNum) = @$parms;
+            my ($len, $msg, $tip, $flag, $tipNum, $ifd) = @$parms;
             next unless $len > 0;
             $flag = 0 unless defined $flag;
@@ -359,6 +396,8 @@
             }
             if ($flag & 0x14) {
+                my $class = $flag & 0x04 ? "$name M" : $name;
+                $class .= " $ifd" if $ifd;
                 my %bkg = (
-                    Class => $flag & 0x04 ? "$name M" : $name,
+                    Class => $class,
                     Start => $start - $dataPos,
                     End   => $start - $dataPos + $len,
@@ -375,5 +414,7 @@
                 $end = $start + $len;
                 # only load as much of the block as we are going to dump
-                my $size = ($len > $limit) ? $limit / 2 : $len;
+                # (read 32 more bytes than necessary just in case there
+                # is only one skipped line that we decide to print)
+                my $size = ($len > $limit + 32) ? $limit / 2 + 16 : $len;
                 if ($start >= $dataPos and $end <= $dataEnd) {
                     $buff = substr($$dataPt, $start-$dataPos, $size);
@@ -418,5 +459,5 @@
             }
             $self->DumpTable($start-$dataPos, \$buff, $msg, $name,
-                             $flag, $len, $pos-$dataPos);
+                             $flag, $len, $pos-$dataPos, $ifd);
             undef $buff;
             $pos = $end if $pos < $end;
@@ -548,8 +589,8 @@
 # Inputs: 0) HtmlDump object ref, 1) data position, 2) block pointer,
 #         3) message, 4) object name, 5) flag, 6) full block length (actual
-#         data may be shorter), 7) data end position
-sub DumpTable($$$;$$$$$)
+#         data may be shorter), 7) data end position, 8) IFD name
+sub DumpTable($$$;$$$$$$)
 {
-    my ($self, $pos, $blockPt, $msg, $name, $flag, $len, $endPos) = @_;
+    my ($self, $pos, $blockPt, $msg, $name, $flag, $len, $endPos, $ifd) = @_;
     $len = length $$blockPt unless defined $len;
     $endPos = 0 unless $endPos;
@@ -578,5 +619,6 @@
             ++$id unless $dblRef;
         }
-        $name = "<a name=$name class=$id>";
+        my $class = $ifd ? "'$id $ifd'" : $id;
+        $name = "<a name=$name class=$class>";
         $msg and $msg = "$name$msg</a>";
     } else {
@@ -643,5 +685,6 @@
             $dblRef = 0;
             ++$id;
-            $name =~ s/class=\w\b/class=$id/;
+            my $class = $ifd ? "'$id $ifd'" : $id;
+            $name =~ s/class=\w\b/class=$class/;
             $f0 = '';
             $self->Open('fgd', $f0, 0);
@@ -713,5 +756,5 @@
 sub FinishTiffDump($$$)
 {
-    my ($self, $exifTool, $size) = @_;
+    my ($self, $et, $size) = @_;
     my ($tag, $key, $start, $blockInfo, $i);
 
@@ -729,19 +772,20 @@
         MPImageStart      => 'MPImageLength',
         IDCPreviewStart   => 'IDCPreviewLength',
+        SamsungRawPointersOffset => 'SamsungRawPointersLength',
     );
 
     # add TIFF data to html dump
     foreach $tag (keys %offsetPair) {
-        my $info = $exifTool->GetInfo($tag);
+        my $info = $et->GetInfo($tag);
         next unless %$info;
         # Panasonic hack: StripOffsets is not valid for Panasonic RW2 files,
         # and StripRowBytes is not valid for some RAW images
-        if ($tag eq 'StripOffsets' and $exifTool->{TAG_INFO}{$tag}{PanasonicHack}) {
+        if ($tag eq 'StripOffsets' and $$et{TAG_INFO}{$tag}{PanasonicHack}) {
             # use RawDataOffset instead if available since it is valid in RW2
-            my $info2 = $exifTool->GetInfo('RawDataOffset');
+            my $info2 = $et->GetInfo('RawDataOffset');
             $info2 = $info unless %$info2;
             my @keys = keys %$info2;
             my $offset = $$info2{$keys[0]};
-            my $raf = $$exifTool{RAF};
+            my $raf = $$et{RAF};
             # ignore StripByteCounts and assume raw data runs to the end of file
             if (@keys == 1 and $offset =~ /^\d+$/ and $raf) {
@@ -759,6 +803,6 @@
         foreach $key (keys %$info) {
             my $name = Image::ExifTool::GetTagName($key);
-            my $grp1 = $exifTool->GetGroup($key, 1);
-            my $info2 = $exifTool->GetInfo($offsetPair{$tag}, { Group1 => $grp1 });
+            my $grp1 = $et->GetGroup($key, 1);
+            my $info2 = $et->GetInfo($offsetPair{$tag}, { Group1 => $grp1 });
             my $key2 = $offsetPair{$tag};
             $key2 .= $1 if $key =~ /( .*)/; # use same instance number as $tag
@@ -791,5 +835,5 @@
                     }
                 }
-                my $msg = $exifTool->GetGroup($key, 1) . ':' . $tag;
+                my $msg = $et->GetGroup($key, 1) . ':' . $tag;
                 $msg =~ s/(Offsets?|Start)$/ /;
                 if ($num > 1) {
@@ -815,5 +859,5 @@
     }
     my $diff = $size - $last;
-    if ($diff > 0 and ($last or $exifTool->Options('Unknown'))) {
+    if ($diff > 0 and ($last or $et->Options('Unknown'))) {
         if ($diff > 1 or $size & 0x01) {
             $self->Add($last, $diff, "[unknown data]", "Size: $diff bytes", 0x08);
@@ -874,5 +918,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
